import React from 'react'
import Svg, { Defs, LinearGradient, Stop, G, Path } from 'react-native-svg'
import { Animated } from 'react-native'

import { screenHeight, screenWidth } from '../styles'

const AnimatedSvg = Animated.createAnimatedComponent(Svg)
const AnimatedPath = Animated.createAnimatedComponent(Path)

const Splash = ({
  strokeWidth = 1,
  splashTextOpacity = 1,
  logoOpacity = 1,
  splashTop,
  splashOpacity,
  ...props
}) => (
  <Animated.View
    style={{
      height: screenHeight,
      width: screenWidth,
      flex: 1,
      position: 'absolute',
      backgroundColor: '#1A1A1A',
      zIndex: 9999,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      top: splashTop,
      opacity: splashOpacity,
    }}
  >
    {+logoOpacity !== 0 && (
      <AnimatedSvg
        width={0.8 * screenWidth}
        height={screenHeight}
        viewBox="0 0 301 90"
        style={{ flex: 1 }}
        logoOpacity={logoOpacity}
        {...props}
      >
        <Defs>
          <LinearGradient
            x1="0%"
            y1="54.303%"
            x2="104.052%"
            y2="45.697%"
            id="prefix__a"
          >
            <Stop stopColor="#72533B" offset="0%" />
            <Stop stopColor="#AB9159" offset="65.901%" />
            <Stop stopColor="#C6AF67" offset="100%" />
          </LinearGradient>
        </Defs>
        <G fill="none">
          <AnimatedPath
            d="M208.87 86.542c-.683-2.611-1.218-6.438-1.782-13.332-.653-7.653-1.276-12.937-1.93-16.096-1.632-7.896-2.374-15.215-1.959-18.708.297-2.338.267-2.43-.445-3.158-.386-.425-1.544-1.033-2.583-1.397-1.158-.395-1.87-.82-1.93-1.124-.089-.455.208-.516 2.138-.516h2.256l.564-1.124c.297-.638.831-1.397 1.158-1.73.623-.548.623-.548 1.098.607 1.158 2.854 3.236 4.525 7.214 5.8 2.375.76 2.999 1.093 2.494 1.428-.119.06-1.692-.183-3.473-.608-4.72-1.032-4.78-1.032-5.017.668-.535 4.07-.12 12.148 1.187 23.355.386 3.523 1.01 8.716 1.336 11.54.327 2.855.653 7.532.772 10.417.148 4.677.119 5.224-.297 5.224-.327 0-.594-.426-.802-1.246zm-22.928-1.84c-1.337-1.386-3.506-2.592-6.982-3.888-3.387-1.267-4.249-1.749-10.578-6.03-5.259-3.588-6.418-4.553-5.794-4.944.12-.09 1.902.693 3.922 1.778 4.636 2.412 16.461 7.688 17.234 7.688.535 0 .594-.15.445-1.266-.118-.724-.386-3.105-.624-5.306-.594-5.276-1.248-8.14-2.08-8.984-.653-.664-2.168-1.206-5.764-2.08-1.01-.242-2.258-.724-2.733-1.086-.951-.693-1.189-1.598-.327-1.357.267.06 2.14.513 4.13.935 2.823.633 3.744.723 4.22.452.356-.18.623-.362.623-.422s-.594-6.813-1.337-14.984c-1.426-15.858-1.426-15.315.09-15.797.593-.181.742-.03 1.277 1.175 1.188 2.774 1.485 5.156 1.753 14.652.297 9.527.535 11.879 1.485 14.743.714 2.08 1.962 3.316 7.577 7.417 7.458 5.456 10.43 9.104 10.37 12.813-.03 1.899-.95 4.01-1.99 4.552-.417.241-2.942.452-6.746.573-3.357.12-6.299.301-6.536.422-.298.12-.862-.211-1.635-1.055zm14.99-2.847c.576-.549.546-.61-.668-3.203-2.458-5.125-5.766-9.152-9.317-11.287-1.7-1.007-4.886-2.197-5.19-1.922-.121.152 1.609 14.307 1.791 14.49.06.061 1.882.733 4.036 1.465 3.703 1.281 4.037 1.342 6.343 1.19 1.79-.123 2.58-.306 3.005-.733zm-81.483.44c0-.703-2.216-16.258-2.34-16.441-.094-.153-1.312-1.131-2.654-2.17-1.373-1.04-2.497-1.987-2.497-2.14 0-.488 1.873-.274 3.153.367.717.337 1.342.581 1.404.49.063-.062-.374-3.668-.999-8.038-.811-5.776-1.155-9.413-1.248-13.416-.187-6.265.187-13.355.655-13.508.5-.152 3.715 2.781 4.807 4.401 1.124 1.65 1.31 3.148.375 3.148-.375 0-.906-.49-1.405-1.345-.437-.733-1.155-1.558-1.623-1.864l-.843-.52.25 2.995c.25 3.637 2.216 23.715 2.653 27.168.343 2.69.343 2.69 4.495 6.051 1.248 1.04 2.715 2.965 2.216 2.965-.469 0-2.497-.978-3.715-1.834-1.31-.856-1.435-.886-1.716-.367-.625 1.162-.687 3.698-.219 7.977.624 5.5.624 5.44-.125 5.837-.343.183-.624.275-.624.244zM18.238 78.697c-.567-.814-1.551-3.436-2.058-5.486-.239-.965-.656-1.236-7.844-5.155-7.159-3.92-9.783-5.759-7.576-5.276.477.09 3.28 1.387 6.233 2.834 5.757 2.833 7.248 3.497 7.457 3.286.09-.06-.12-2.894-.447-6.27-.657-6.814-.686-6.905-2.983-7.9-1.283-.542-1.79-.994-1.79-1.537 0-.15.776-.18 1.76-.06 1.014.12 1.82.09 1.939-.09.209-.362-2.714-25.716-3.013-25.987-.119-.12-1.252-.603-2.475-1.055-2.774-1.025-3.162-1.357-1.64-1.357 5.249 0 15.539 2.834 22.488 6.21 7.815 3.769 13.005 8.441 14.675 13.205.746 2.17.746 5.336 0 6.964-1.491 3.316-6.263 5.667-12.318 6.09l-2.595.18.507.905c.268.482 1.85 1.929 3.46 3.195 6.71 5.185 8.053 6.693 9.007 10.22.507 1.809.507 1.9-.06 2.502-2.684 2.985-10.647 3.105-18.313.271-1.64-.603-2.445-.753-2.595-.512-.09.18-.179 1.176-.149 2.2.06 1.93-.298 3.437-.805 3.437-.15 0-.537-.361-.865-.814zm20.86-5.321c.483-.338.634-.614.483-1.104-.634-2.115-2.776-4.997-5.945-8.063-5.402-5.212-12.01-8.707-15.36-8.155l-1.178.184.182 1.717c.784 6.99 1.72 10.3 3.35 11.895 1.086 1.012 1.75 1.226 8.268 2.422 1.57.306 3.833.858 4.98 1.226 2.293.736 3.983.705 5.22-.122zm-4.936-18.179c5.702-1.406 8.132-4.035 7.772-8.437-.48-5.93-9.092-13.144-20.495-17.24-3.06-1.07-6.992-1.987-7.292-1.681-.12.122-.18 2.017-.15 4.218.06 7.642 2.61 23.079 3.781 23.17.21 0 1.44.215 2.76.429 3.362.61 10.293.366 13.624-.459zm219.739 12.537c-5.168-1.499-6.398-1.989-7.444-2.94-.985-.893-1.077-1.528-.308-2.19 1.292-1.096 2.03-.923 4.614.893 2.522 1.816 3.26 2.075 7.136 2.652 2.615.403 4.522 1.095 5.322 1.93.523.577.523.577-1.538.75-3.045.289-3.23.26-7.782-1.095zm-21.96-1.251c-3.978-5.18-7.014-11.67-8.35-17.832-1.457-6.55-1.73-14.499-.455-13.248.091.09.486 1.637.85 3.453.364 1.846.82 3.454.972 3.602.121.12 2.368 1.578 4.949 3.216 4.25 2.65 4.736 2.887 5.1 2.44.425-.476.365-3.155-.121-6.132l-.182-1.19.85.803c.79.774.85 1.012 1.063 4.227.273 4.287.546 4.793 3.947 6.877 1.427.893 2.854 1.906 3.157 2.233.547.596.547.596-.516.596-.729 0-1.67-.387-2.945-1.191l-1.882-1.191-.304.774c-.152.446-.243 2.62-.213 4.853.092 4.584-.121 5.299-2.034 6.192-1.002.476-1.032.446-2.034-.358-.91-.744-2.368-2.679-2.368-3.185 0-.476 1.245-.536 2.247-.119 1.062.447 1.123.417 1.609-.327.637-.923.85-3.9.546-7.116l-.212-2.232-4.95-3.245c-2.732-1.787-5.04-3.156-5.1-3.037-.698 1.22-.213 4.644 1.184 8.306 1.123 2.947 3.826 8.246 5.435 10.628.759 1.131 1.366 2.292 1.366 2.59 0 .863-.79.655-1.61-.387zm55.53.128c-3.374-2.957-8.091-13.324-9.524-20.853-.777-4.033-.478-10.486.447-10.486.15 0 .27.06.27.12 0 .388 1.522 7.438 1.641 7.677a.79.79 0 00.567.27c.777 0 5.225 2.39 6.748 3.644 2.836 2.3 2.806 2.33 2.538-1.972-.15-2.718-.12-3.764.149-3.913a.54.54 0 01.627.06c.18.179 1.463 7.677 1.463 8.603 0 .09.985.777 2.18 1.584 2.179 1.494 4.687 3.764 4.687 4.302 0 .359-.836.09-3.404-1.135-2.866-1.375-2.926-1.375-2.657.717.15.926.239 2.838.239 4.242 0 3.077-.657 4.6-2.329 5.527l-1.075.598-1.224-1.195c-.687-.658-1.433-1.584-1.702-2.062-.388-.747-.388-.896 0-1.285.388-.388.597-.358 1.672.21.687.328 1.344.537 1.493.478.836-.538 1.254-6.902.627-9.202-.418-1.494-2.388-3.167-6.479-5.527-2.209-1.315-3.284-1.793-3.523-1.554-.597.598-.298 3.914.597 6.543.926 2.749 3.971 8.903 6.27 12.638 1.642 2.718 1.523 3.555-.298 1.971zm-21.806-1.686c-6.891-5.825-12.674-12.53-14.92-17.264-1.538-3.216-2-4.915-2-7.403 0-1.608.062-1.85.585-1.85.708 0 3.2 2.639 5.322 5.612.861 1.153 3.138 4.794 5.106 8.04 4.092 6.827 6.706 10.772 8.306 12.501 1.077 1.184 1.077 1.244.523 1.639-.308.242-.646.425-.738.425-.093 0-1.077-.79-2.184-1.7zm-120.473-1.78c-.632-1.961-.843-3.832-1.054-10.502-.33-10.05-.752-11.588-4.123-14.817-3.1-2.988-5.78-4.859-6.593-4.678-1.023.272-1.174 1.147-1.174 6.971 0 4.406.151 5.945.994 10.955.542 3.199.903 5.945.813 6.096-1.174 1.931-3.402-4.376-4.064-11.468-.391-4.134-.03-9.144.843-12.433.421-1.51.692-1.962 1.354-2.294.783-.392.964-.302 4.515 2.233 2.017 1.449 4.094 3.048 4.636 3.531l.963.906.211-.845c.451-1.871-.361-8.27-1.836-14.124-.903-3.5-3.251-10.924-4.997-15.753-2.318-6.277-2.378-8.36-.21-5.945 2.347 2.595 4.304 6.67 6.08 12.554 1.324 4.286 3.28 14.033 3.913 19.194.27 2.082.632 4.979.813 6.458.33 2.655 1.143 5.583 1.956 7.152.391.754.361.815-.3.996-1.054.271-1.205 1.69-.783 7.303.39 5.01.27 7.726-.332 8.45-.421.513-1.444.543-1.625.06zm-40.94-2.516c-.97-2.307-1.706-5.784-2.352-10.86-1.03-8.307-1.793-11.014-3.792-13.66-.94-1.231-3.116-2.615-4.644-2.954-.735-.154-1-.061-1.205.37-.823 1.63-1.235 11.783-.617 15.352.176.984.705 3.322 1.205 5.168.705 2.677.793 3.385.5 3.6-.588.37-1.059-.215-1.705-2.03-1.529-4.277-2.616-14.276-2.087-19.137.323-3.2.646-4.246 1.528-5.23 1.323-1.477 3.175-.616 7.113 3.292 1.734 1.753 2.851 2.676 2.969 2.43.117-.184.5-1.323.852-2.523.647-2.276 1.205-2.892 1.5-1.692.087.4.205 2.585.234 4.861l.06 4.154 2.145 2.707c1.146 1.508 2.116 2.83 2.116 2.984 0 .677-.705.585-1.91-.307l-1.323-.954v1.784c0 .985.264 3.385.588 5.323.852 5.2.735 8.615-.324 8.615-.176 0-.558-.585-.852-1.293zm-30.865-3.883c-2.166-2.284-3.55-4.537-4.993-8.07-1.805-4.353-3.068-11.357-3.068-16.808 0-2.01.09-2.344.632-2.618.33-.213.691-.305.752-.213.09.06.33 1.887.601 4.019.24 2.131.511 3.989.572 4.11.09.123.511.336.962.457.481.092 2.136.914 3.7 1.797 1.564.914 3.459 1.949 4.18 2.314l1.324.67-.24-3.258c-.15-2.527-.12-3.228.15-3.045.662.426 1.203 2.253 1.203 4.08 0 2.65.3 3.198 2.707 4.75 1.143.762 2.106 1.493 2.106 1.675 0 .366.18.396-1.805-.152-1.925-.518-2.316-.304-1.835 1.066.541 1.614.722 4.628.361 5.998-.752 2.802-2.978 3.929-4.752 2.406-.873-.761-1.835-2.466-1.534-2.77.09-.092.722.03 1.413.304 2.316.822 2.768.03 2.768-4.69 0-2.192-.15-3.319-.391-3.562-1.113-1.005-9.686-5.908-9.926-5.664-.331.335.872 5.724 1.955 8.617 1.143 3.076 2.226 5.085 4.331 7.978 1.504 2.101 1.805 2.65 1.354 2.65-.301 0-1.444-.914-2.527-2.04zm-18.786-4.261c-2.915-3.049-3.272-3.603-4.462-7.083-.804-2.279-2.291-4.866-2.797-4.866-.386 0-1.487-1.139-1.487-1.54 0-.153.476-.307 1.041-.307h1.041l-.238-1.91c-.267-2.525-.267-7.514.03-7.822.119-.123.922-.277 1.815-.37 2.915-.246 6.723 1.387 7.913 3.388.327.555.535 1.047.476 1.109-.09.062-1.399-.524-2.975-1.324-3.54-1.756-4.611-1.786-5.028-.154-.148.585-.208 2.34-.148 3.88.119 3.85.624 4.496 5.116 6.713 1.845.924 3.808 2.125 4.343 2.68 1.28 1.354 2.261 3.572 2.708 6.19.356 2.032.327 2.124-.328 2.863-.386.431-1.16.832-1.755.955-.595.092-1.398.215-1.814.308-.625.123-1.19-.339-3.451-2.71zm3.986.037c.498-.278.557-.525.41-1.606-.44-2.873-2.023-5.127-5.072-7.197-1.847-1.266-2.873-1.39-2.58-.34.674 2.44 2.052 4.788 4.163 7.043 1.232 1.359 2.287 2.44 2.346 2.44.088 0 .41-.155.733-.34zM265.19 41.049c-1.84-.698-6.529-2.157-10.39-3.267-7.877-2.252-8.705-2.696-8.306-4.599l.214-1.046 1.9.19c2.452.222 3.924.761 9.992 3.71 5.333 2.57 7.356 3.363 10.114 3.966 1.471.285 1.686.444 1.778 1.173.061.603-.061.856-.613 1.015-.98.254-.95.285-4.69-1.142z"
            stroke="#1A1A1A"
            fill="url(#prefix__a)"
            transform="matrix(1 0 0 -1 1 88.788)"
            strokeWidth={strokeWidth}
            strokeLinecap="round"
            strokeLinejoin="round"
          />
          <AnimatedPath
            d="M161.439 86.714V75.4h1.068v4.856h6.695V75.4h1.068v11.314h-1.068v-5.547h-6.695v5.547h-1.068zm14.217 0V75.4h7.528v.911h-6.459v4.086h5.83v.912h-5.83v4.494h6.616v.911h-7.685zm11.421 0l4.447-11.314h1.21l4.337 11.314h-1.1l-1.304-3.551h-5.154l-1.336 3.551h-1.1zm2.797-4.463h4.432l-2.216-5.94-2.216 5.94zm11.578 4.463V75.4h1.068v10.403h6.066v.911h-7.134zm9.126-11.314h8.234v.911h-3.582v10.403h-1.069V76.311h-3.583V75.4zm12.6 11.314V75.4h1.068v4.856h6.694V75.4h1.069v11.314h-1.069v-5.547h-6.694v5.547h-1.069zm24.082-5.893a4.708 4.708 0 00-.872.527 3.719 3.719 0 00-.692.683 3.372 3.372 0 00-.463.81 2.37 2.37 0 00-.173.888c0 .377.065.715.196 1.013a2.274 2.274 0 001.336 1.25 2.88 2.88 0 001.014.172c.607 0 1.144-.139 1.61-.416a4.958 4.958 0 001.265-1.092l-3.221-3.835zm2.027-2.592a1.38 1.38 0 00.118-.668 1.374 1.374 0 00-.204-.645 1.448 1.448 0 00-.495-.479 1.44 1.44 0 00-.755-.188 1.68 1.68 0 00-.565.094 1.59 1.59 0 00-.48.267 1.247 1.247 0 00-.464.99c0 .168.043.351.126.55.084.199.186.393.307.581.12.189.249.37.385.543.136.172.257.322.361.447.315-.188.632-.395.951-.62.32-.226.558-.516.715-.872zm1.729 5.562c.199-.335.327-.688.385-1.06a7.43 7.43 0 00.086-1.14h.927a8.954 8.954 0 01-.196 1.533c-.11.508-.307.982-.59 1.422l1.84 2.168h-1.274l-1.1-1.335c-.492.586-1.021 1.005-1.587 1.257-.566.251-1.226.377-1.98.377-.492 0-.953-.081-1.383-.244a3.442 3.442 0 01-1.123-.683 3.157 3.157 0 01-.755-1.061 3.357 3.357 0 01-.275-1.375c0-.419.074-.807.22-1.163.147-.356.343-.68.59-.974a4.33 4.33 0 01.856-.778c.325-.225.67-.422 1.037-.59a8.885 8.885 0 01-.833-1.154 2.597 2.597 0 01-.377-1.375c0-.356.068-.673.204-.951.137-.278.32-.51.55-.7.231-.188.5-.33.81-.424.309-.094.636-.141.982-.141s.665.058.958.173c.294.115.545.272.755.471.21.2.372.432.487.7a2.1 2.1 0 01.173.84c0 .377-.06.705-.18.982a2.534 2.534 0 01-.488.739 4.008 4.008 0 01-.715.59c-.272.177-.555.355-.849.534l2.845 3.362zm14.607-.455c.041.503.154.93.337 1.28.184.351.42.637.708.857.288.22.62.38.997.48.378.099.78.148 1.21.148.503 0 .938-.062 1.305-.188a2.48 2.48 0 00.895-.51 2.02 2.02 0 00.511-.747 2.45 2.45 0 00.165-.896c0-.44-.1-.796-.298-1.069a2.303 2.303 0 00-.778-.667 4.761 4.761 0 00-1.1-.417 57.15 57.15 0 00-1.273-.306c-.435-.1-.86-.218-1.273-.354a4.007 4.007 0 01-1.1-.55 2.658 2.658 0 01-.778-.888c-.199-.361-.298-.82-.298-1.375a2.795 2.795 0 01.966-2.105c.32-.283.72-.509 1.202-.676.482-.168 1.037-.252 1.666-.252.639 0 1.197.09 1.673.268.477.178.873.421 1.187.73.314.31.55.668.707 1.077.157.408.236.843.236 1.304h-1.022c0-.43-.076-.801-.228-1.116a2.093 2.093 0 00-.62-.77 2.65 2.65 0 00-.896-.44 3.812 3.812 0 00-1.037-.141c-.545 0-1.003.076-1.375.228-.372.152-.668.348-.888.589a1.99 1.99 0 00-.456.801c-.084.294-.1.587-.047.88.063.367.21.66.44.88.23.22.513.401.849.543.335.141.704.256 1.108.345.403.09.814.184 1.233.283.42.1.825.218 1.218.354.393.136.741.32 1.045.55.304.23.547.526.73.888.184.361.276.814.276 1.359 0 1.047-.362 1.86-1.085 2.436-.722.576-1.739.864-3.048.864a5.628 5.628 0 01-1.634-.228 3.62 3.62 0 01-1.305-.691 3.176 3.176 0 01-.856-1.148c-.204-.455-.307-.992-.307-1.61h1.038zm11.97 3.378V75.4h4.133c.733 0 1.338.084 1.815.251.477.168.854.399 1.131.692.278.293.472.631.582 1.013.11.383.165.784.165 1.203 0 .628-.129 1.147-.385 1.555a2.85 2.85 0 01-.998.967c-.409.235-.872.4-1.39.495a8.723 8.723 0 01-1.564.141h-2.42v4.997h-1.069zm3.52-5.908c.503 0 .953-.032 1.352-.095.398-.062.735-.18 1.013-.353a1.75 1.75 0 00.644-.707c.152-.299.228-.69.228-1.171 0-.712-.233-1.252-.699-1.619-.466-.366-1.207-.55-2.224-.55h-2.765v4.495h2.451zm6.785 5.908l4.447-11.314h1.21l4.337 11.314h-1.1l-1.304-3.551h-5.154l-1.336 3.551h-1.1zm2.797-4.463h4.432l-2.216-5.94-2.216 5.94z"
            fill="#FFF"
            opacity={splashTextOpacity}
          />
        </G>
      </AnimatedSvg>
    )}
  </Animated.View>
)

export default Splash
